* retpat - Return Parameters (via parameter list) According to Type
*                 PWITTE December 27th 1992
*

        section code

        xdef retpat             not pet rat!

        xref bplet
        xref sb_str2flt,sb_str2int
        xref sb_flt2str,sb_flt2int
        xref sb_int2str,sb_int2flt
        xref sb_lin2str,sb_lin2flt,sb_lin2int

*
retpat
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert a given input value on the RI stack to an appropriate output value
* and return through parameter list
*
* Notes: Arrays and substrings are not handled by this routine
*        If the target parameter was a null or expression the routines exits
*        successfully but no value is actually returned
*
* input  :
*          d0.b = value type 1=str, 2=flt, 3=int, 4=lin
*          d1.b = return parameter type (as above (except lin))
*          a1  -> value on stack
*          a3 ->  return parameter (must exist!)
*      $58(a6)->  bv.rip           (must be current)
*
* return :   cc   set
*          d0.l = error XP, CV, BP, no error if expression or nul
*          a3  -> next parameter (if successful output only)
*          d1   = ???
*          remainder unchanged
*
regs    reg d2-d4/a0-a2
        movem.l regs,-(a7)
        lea.l   rp_jmp,a2       get base of jump table
        lsl.w   #1,d0           convert in-type to table offset
        cmp.b   #2,d1           set cc according to type
rp_putp
        jsr     0(a2,d0.w)      cc set from parinfo. Put par, convert if nec.
        tst.l   d0              any errors?
        bne.s   rp_quit           yes, so quit
        bsr     bplet             no, so stuff variable
rp_quit
        movem.l (a7)+,regs
        rts
*
rp_jmp
        nop                     saves a subq.w #1,d3 above
        bra.s   rp_str          jump to string  -> ? conversion routine
        bra.s   rp_flt          jump to float   -> ? conversion routine
        bra.s   rp_int          jump to integer -> ? conversion routine
rp_lin
        beq     sb_lin2flt      lint  -> float
        bmi     sb_lin2str      lint  -> string
        bra     sb_lin2int      lint  -> integer
rp_int
        beq     sb_int2flt      integer -> float
        bmi     sb_int2str      integer -> string
rp_ss   moveq   #0,d0           same    -> same (no conversion)
        rts
rp_flt
        bmi     sb_flt2str      float  -> string
        bgt     sb_flt2int      float  -> integer
        bra.s   rp_ss           no conversion
rp_str
        beq     sb_str2flt      string -> float
        bmi.s   rp_ss           no conversion
        bra     sb_str2int      string -> integer
*
        end
