* fputp
*
* pjwitte 2oi8+
* All code is my own work except as and where stated
*
* V0.01, pjw, 2019 Jul 21
*
* Compatible with QDOS, Minerva and SMSQ/E
*

        section code

        xdef fputp

        include dev8_keys_qlv
        include dev8_keys_sbasic

*
fputp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Return a float through parameter list. Only act if parameter is float
* Any other parameter type is skipped, but not reported as error.
*
*       call                          return
* a1    -> float on ri stack (a6 rel)
* a3    -> parameter         -> next parmater (if any)
* all other registeres preserved
*
* If parameter is not a scalar set or unset float, then skip
*
* Stack updated
*

regs    reg d1-d3/a0-a2

        move.w (a6,a3.l),d0     get par type
        andi.w #$0f0f,d0        strip
        cmpi.w #$202,d0         scalar float?
        beq.s doit               good!

        cmpi.w #$2,d0           unset float?
        beq.s doit               ok

not_ok
        moveq #0,d0              no, no error, just
        bra.s rts                 dont do it

doit
        movem.l regs,-(sp)
        move.w sb.putp,a2       bp.let
        jsr (a2)
        movem.l (sp)+,regs

rts
        addq.l #nt.len,a3       next par
        rts

*



        end
