* Convert buffer mode 16 to mode 64 using nybble sized table
*
* V0.01, pjwitte 2oi9+
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*

        section code

        xdef ut_bf16to64n

        xref tab_aur8rgbn
        xref cv_16to24n

*
ut_bf16to64n
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert buffer with 8bit graphics data mode 16 to 32bit mode 64
* Target buffer must be different and 4 x size of source buffer!
* No padding
*
* input:
* d1.l = input buffer len in bytes
* a2  -> input buffer
* a4  -> output buffer
*
* output:
* a2/a4           updated
* d1/d3-d6/a1/a3  smashed
*
* Always "succeeds" - no error or CC
*

        lea.l tab_aur8rgbn,a3

        bra.s lend

loop
        move.b (a2)+,d3

        bsr cv_16to24n

        lsl.l #8,d3             convert 24bit to mode 64

        move.l d3,(a4)+

lend
        subq.l #1,d1
        bpl.s loop

        rts

*
        end
