* Convert RGB to native colour
*
* V0.01, pjwitte 2oi9+
*
* Conversion code, V2.00   1998, Tony Tebby, taken from SMSQ/E sources
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*


        section code

        xdef ut_bf64to16

        xref tab_rgb2aur
        xref cv_64to16


*
ut_bf64to16
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert buffer of 32bit RGB mode 64 graphics data to mode 16 (Aurora)
* Source and target buffers can be the same
* No padding
*
* input:
* d1.l = input buffer len in bytes
* a2  -> input buffer
* a4  -> output buffer
*
* output:
* a2/a4       updated
* d0/d1/d3/a3 smashed
*
* Always "succeeds" - no error or CC
*

        lea.l tab_rgb2aur(pc),a3
        moveq #10,d0

        bra.s lend

loop
        move.l (a2)+,d3

        bsr cv_64to16

        move.b d3,(a4)+

lend
        subq.l #4,d1
        bpl.s loop

        rts

*
        end
