* Convert RGB to native colour
*
* V0.01, pjwitte 2oi9+
*
* Conversion code, V2.00   1998, Tony Tebby, taken from SMSQ/E sources
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*


        section code

        xdef ut_bf64to3x


*
ut_bf64to3x
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert buffer of 32bit RGB mode 64 graphics data to 16bit mode 3X
* Source and target buffers can be the same
* No padding
*
* d0   = routine-dependent value, eg 11
* d1.l = input buffer len in bytes
* a1  -> routine: eg cv_64to32 or cv_64to33
* a2  -> input buffer
* a4  -> output buffer
*
* a2/a4       updated
* d0/d1/d3    smashed
*
* Always "succeeds" - no error or CC
*

        moveq #11,d0
        bra.s lend

loop
        move.l (a2)+,d3

        jsr (a1)

        move.w d3,(a4)+

lend
        subq.l #4,d1
        bpl.s loop

        rts

*
        end
