* Convert RGB to native colour
*
* V0.01, pjwitte 2oi9+
*
* Conversion code, V2.00   1998, Tony Tebby, taken from SMSQ/E sources
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*


        section code

        xdef ut_bf64to3xp


*
ut_bf64to3xp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert buffer of 32bit RGB mode 64 graphics data to 16bit mode 3X
* Source and target buffers can be the same
* With padding (eg for sprites)
*
* d0   = routine-dependent value, eg 11
* d1.l = input buffer len in bytes
* d2.w = x-size in pixels
* a1  -> routine: eg cv_64to32 or cv_64to33
* a2  -> input buffer
* a4  -> output buffer
*
* a2/a4       updated
* d0-d4       smashed
*
* Always "succeeds" - no error or CC
*

        move.w d2,d4
        moveq #11,d0            superfluous for cv64to33
        bra.s lend

loop
        move.l (a2)+,d3

        jsr (a1)

        move.w d3,(a4)+

        subq.w #1,d4
        bne.s lend

pad
;       addq.l #2,a4            pad this line with random data
        clr.w (a4)+             pad this line with black
        move.w d2,d4            start again

lend
        subq.l #4,d1
        bpl.s loop

        rts

*
        end
