* Native colour conversion
*
* V0.01, 2oi8+, pjwitte, algorithm by W Lenerz, 2004
* V0.02, pjw, 2019 Jul 24, changed register usage
*
* Compatible with all GD2 modes
*

        section code

        xdef cv_32to24
        xdef ut_cv32to24

*
ut_cv32to24
*
cv_32to24
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* entry:
*       d3.W = gggbbbbb rrrrrggg        - QPC/QXL (mode 32) colour to convert
*
* exit:
*       d0 smashed
*       d3 = 0 R G B                    - 24 bit mode colour code
*
* no error codes set or checked, routines always succeed


        move.w d3,d0            ; ??? rrrrrggg
        andi.l #%11111000,d3    ; ... rrrrr000
        swap d3                 ; red into high word  = 0 R 0 0
        rol.w #8,d0             ; rrrrrggg gggbbbbb
        move.b d0,d3            ; ... gggbbbbb
        lsl.b #3,d3             ; ... bbbbb000 - d0 = 0 R 0 B
        andi.b #%11100000,d0    ; rrrrrggg ggg00000
        lsl.w #5,d0             ; gggggg00 00000000
        or.w d0,d3              ; 0 R G B

        rts

*
        end
