* cv_33to16
*
* V0.01, pjwitte 2oi9+
*
* Conversion code, V2.00   1998, Tony Tebby, taken from SMSQ/E sources
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*

        section code

        xdef ut_cv33to16
        xdef cv_33to16

        xref tab_rgb2aur

*
ut_cv33to16
        lea.l tab_rgb2aur,a3
        move.w #%111000000,d0

*
cv_33to16
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert one item of mode 33 graphics data to mode 16
*
* input:
* d0   = some constant
* d3.w = gggggrrr rrbbbbbw      - colour to convert
* a3  -> tab_rgb2aur
*
* output:
* d3.w = rrgggbbb
* d0/a3  preserved
* d4     smashed
*
* Always "succeeds" - no error or CC
*
        move.w   d3,d4
        lsl.b    #2,d3             ; gggggrrr bbbbbw00
        lsr.w    #5,d3             ; 00000ggg ggrrrbbb
        lsl.b    #5,d3             ; 00000ggg bbb00000
        lsr.w    #5,d3             ; 00000000 00gggbbb
        lsr.w    #2,d4
        and.w    d0,d4             ; 0000000r rr000000
        or.w     d4,d3             ; 0000000r rrgggbbb
        move.b   (a3,d3.w),d3

        rts

*
        end
