* Convert RGB to native colour
*
* V0.01, pjwitte 2oi9+
*
* Conversion code, V2.00   1998, Tony Tebby, taken from SMSQ/E sources
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*


        section colour

        xdef ut_cv64to16
        xdef cv_64to16

        xref tab_rgb2aur

*
ut_cv64to16
        lea.l tab_rgb2aur(pc),a3
        moveq #10,d0

*
cv_64to16
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert one item of 32bit RGB mode 64 graphics data to mode 16 (Aurora)
*
* input:
* d0.l = 10             - constant required for conversion
* d3.l = RGB0           - colour to convert
* a3  -> tab_rgb2aur    - translation table
*
* output:
* d0   = unchanged
* d3.b = grbgrbgx       - 8-bit colour, mode 16
*
* All other regs unchanged
*
* Always "succeeds" - no error or CC
*


        lsr.l    #8,d3
        lsr.b    #5,d3                      ; convert values to 3 bit
b_ok    ror.l    #8,d3
        lsr.b    #5,d3
g_ok    ror.l    #8,d3
        lsr.b    #5,d3
        swap     d3
        lsl.b    #5,d3
        lsl.w    #5,d3
        lsr.l    d0,d3
        move.b   (a3,d3.w),d3

        rts

*
        end
