* Convert RGB to native colour
*
* V0.01, pjwitte 2oi9+
*
* Conversion code, V2.00   1998, Tony Tebby, taken from SMSQ/E sources
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*


        section code

        xdef ut_cv64to32
        xdef cv_64to32


*
ut_cv64to32
        moveq #11,d0

*
cv_64to32
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert one item of 32bit RGB mode 64 graphics data to mode 32 (QPC/QXL)
*
* input:
* d0   = 11             - constant required for conversion
* d3.l = RGB0           - colour to convert
*
* output:
* d0   = preserved
* d3.w = GGGBBBBB RRRRRGGG
*
* All other registers unchanged
*
* Always "succeeds" - no error or CC
*

        lsr.l    d0,d3          ........ ...RRRRR rrrGGGGG GggBBBBB
        lsl.w    #1,d3          ........ ...RRRRR rrGGGGGG ggBBBBB.
        lsl.b    #2,d3          ........ ...RRRRR rrGGGGGG BBBBB...
        lsl.w    #2,d3          ........ ...RRRRR GGGGGGBB BBB.....
        lsr.l    #5,d3          ........ ........ RRRRRGGG GGGBBBBB
        ror.w    #8,d3          swap bytes

        rts

*
        end
