* Get address of extended CDB
*
* pjwitte 2oi9+
* All code is my own work except as and where stated
*
* V0.01, pjw, May 30th 2019, extracted as separate function
*
* Compatible with QDOS / Minerva + PE (?), or SMSQ/E
*


        section code

        xdef ut_getxcdb

        include dev8_keys_qdos_sms
        include dev8_keys_sys
        include dev8_keys_con
        include dev8_keys_chn

*
ut_getxcdb
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get address of eXtended Channel Definition Block (PE)
*
* return d1.l current job ID
*        d2.l ASCII OS version number
*        d6.l = CDB, or -1 if none found
*        a0  -> sys vars
*        a2  -> CDB, or undefined if none found
*        a4  -> con linkage
*        remainder unchanged
*        cc   = N if not found?

        moveq #sms.info,d0
        trap #do.smsq           get ptr to system variables in a0

        move.l sys_clnk(a0),a4  ptr to CON linkage

        move.l pt_cchad(a4),d6  current channel address (CDB)
        bne.s  found

notfound
        moveq #-1,d6
        rts

found
        sub.l #sd.extnl,d6
        move.l d6,a2            a2 -> extended CDB
        rts

*
        end
