* Get console's current ink colour
*
* V0.01 - By Wolfgang Lenerz February 13th 2004
*         packaged by pjwitte

        section code

        xdef ut_gtink

        include dev8_keys_con
        include dev8_keys_qdos_io
        include dev8_keys_sys


*
ut_gtink
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get console's current ink colour. GD2 compatible
*
* input : a0   = channel ID
*
* return: cc set
*         d1.l = ink colour (lsb for QL modes)
*         all other registers preserved
*         errors: channel
*

regs    reg d3/a1/a2

        movem.l regs,-(a7)

        moveq #0,d3             ignore buried

        lea.l gtink,a2
        moveq #iow.xtop,d0
        trap #do.io

        movem.l (a7)+,regs

        tst.l d0
        rts

*
gtink
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* xtop routine to get a channel's current ink colour via CDB. Native colour
* in GD2
* GD2 compatible across platforms (one hopes)
*
* call with:
*         d3.w = timeout
*         a0   = channel ID
*         a2   = address of this routine
* return: cc set
*         d1.l = ink colour (lsb for QL modes)
*         a1     ???
*         all other registers preserved
*         errors: channel
*
        clr.l d1

* mode4
        move.b sd_icolr(a0),d1  prepare for mode 4 colour byte
        move.l sys_clnk(a6),a1  ptr to console linkage
        move.b pt_dmode(a1),d0  display mode
        subq.b #8,d0            test mode for 0,2,8
        ble.s gi_out            QL mode 2,4 or 8

        move.l sd_imask(a0),d1  prepare mask
        sub.b #24,d0            QPC/QXL mode?
        bne.s gi_out             ... no ->

* roll
        rol.l #8,d1             rotate mask !!!!!!!!!!!!

gi_out
        moveq #0,d0
        rts

*
        end
