* Convert a floating point number to a string
*
         section code

         xdef   flt2str

*
flt2str
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Description: Convert a floating point number to a string in a buffer
*
* input :
*       a0  -> buffer
*       a1  -> float on (a) stack
*
* return:   cc set
*       d1.l = len
*       a0  -> string (len + chars)
*       a1     updated (-6)
*       errors: no fail
*       no other registers affected
*
regs    reg     d2-d3/a0/a2-a3
        movem.l regs,-(a7)
        addq.l  #2,a0           leave room for len
        move.w  $f0,a2          cv.fpdec
        jsr     (a2)
        move.l  a0,d1           a0 -> end of string
        movem.l (a7)+,regs      get pointer to start of string, etc
        sub.l   a0,d1           d1.l will be len
        subq.l  #2,d1             not length + len word
        move.w  d1,0(a6,a0.l)   put len in place
        moveq   #0,d0
        rts
*
        end
