* Utility to convert a long integer to a floating point value
* PWITTE June 30th 1995
*
        section code

        xdef    lin2flt,int2flt
*
int2flt
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert a word integer in d1 to a floating point number on a stack
* (see below)
*
        ext.l d1
*
lin2flt
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert a long integer in d1 to a floating point number on a stack
*
* input :
*        d1.l = long integer to convert
*        a1  -> six free bytes on stack
*
* return :   cc set
*        a1  -> floating point number on stack
*        d1   = ???
*        errors: always 0
*
        moveq   #0,d0
        tst.l   d1              if 0 skip all this
        beq.s   l2f_ret
        move.w  #$81F,d0        exponent bias
*
lin_loop
        add.l   d1,d1           normalise: loop until
        dbvs    d0,lin_loop       sign changes (fiddling exp all the while)
*
        roxr.l  #1,d1           back one restoring last bit shifted out

l2f_ret
        move.w  d0,0(a6,a1.l)   that's exponent done
        move.l  d1,2(a6,a1.l)   that's the mantissa done
        moveq   #0,d0           never fails
        rts
*

        end
