* Utility to convert a long integer to a floating point value
* PWITTE June 30th 1995, 2oo4
*
* V0.02, pjw, 2oo4, fast version
*
* Fastest among all lin to fp routines tested from various sources.
* See uti_cv_tst_Test0..4!

        section code

        xdef    lin2fltf,int2fltf

*
int2fltf
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert a word integer in d1 to a floating point number on a stack
* (see below)
*
        ext.l d1

*
lin2fltf
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert a long integer in d1 to a floating point number on a stack
* Fast (and bulky) version 2oo4
*
* input :
*        d1.l = long integer to convert
*        a1  -> six free bytes on stack
*
* return :   cc set
*        a1  -> floating point number on stack
*        d1   = ???
*        errors: always 0
*
        swap    d1
        beq.s   l2f0_ret        if zero: Done
        bmi.s   long            word neg but long pos!

        tst.w   d1
        beq.s   short           number is small or zero

*
long
        move.w  #$81F,d0        exponent bias
        swap    d1

llin_loop
        add.l   d1,d1           normalise: loop until
        dbvs    d0,llin_loop     sign changes (fiddling exp all the while)

        bra.s   rox_ret

*
l2f0_ret
        clr.w  0(a6,a1.l)       that's exponent done
        clr.l  2(a6,a1.l)       that's the mantissa done
        moveq   #0,d0           never fails
        rts

*
short
        move.w  #$81F-16,d0     exponent bias (adjusted for short)

lin_loop
        add.l   d1,d1           normalise: loop until
        dbvs    d0,lin_loop       sign changes (fiddling exp all the while)

*
rox_ret
        roxr.l  #1,d1           back one restoring last bit shifted out

*
l2f_ret
        move.w  d0,0(a6,a1.l)   that's exponent done
        move.l  d1,2(a6,a1.l)   that's the mantissa done
        moveq   #0,d0           never fails
        rts

*
        end
